<template>
  <v-app>
    <v-row justify-center>
      <v-flex>
        <v-card>
          <v-card-text>
            <Form ref="form" :fields="editableFields" v-model="editedItem" />
            <v-btn @click="changeData">Change Data</v-btn>
            <v-btn @click="validate">Validate</v-btn>
          </v-card-text>
        </v-card>
      </v-flex>
    </v-row>
  </v-app>
</template>

<script lang="ts">
import Vue from "vue";
import Form from "@/components/Form.vue";
export default Vue.extend({
  name: "App",
  components: { Form },
  data() {
    return {
      editableFields: [
        /* 
        {
          id: "text",
          type: "v-text-field",
          props: {
            counter: true,
            outlined: true,
            label: "text",
            type: "text",
            rules: [
              // @ts-ignore
              v => v === this.editedItem.password || "no match",
              // @ts-ignore
              v => !!v || "required"
            ],
            "prepend-inner-icon": "mdi-account"
          },
          events: {
            // @ts-ignore
            "click:prepend-inner": v => console.log(v)
          }
        },
        {
          id: "password",
          type: "v-text-field",
          props: {
            counter: true,
            outline: true,
            label: "password",
            type: "password"
          },
          events: {
            "click:append": () => {
              // @ts-ignore
              const index = this.editableFields.findIndex(
                // @ts-ignore
                i => i.id === "password"
              );
              // @ts-ignore
              this.editableFields[index].props.type =
                // @ts-ignore
                this.editableFields[index].props.type === "text"
                  ? "password"
                  : "text";
            }
          }
        },
        {
          id: "number",
          type: "v-text-field",
          cols: 6,
          props: {
            counter: true,
            outline: true,
            label: "number",
            type: "number"
          }
        },
        {
          id: "date",
          cols: 6,
          type: "DateInput",
          props: {
            counter: true,
            outline: true,
            label: "date"
          },
          events: {
            // @ts-ignore
            input: v => console.log(v)
          }
        },
        {
          id: "time",
          type: "TimeInput",
          props: {
            counter: true,
            outlined: true,
            label: "time",
            format: "24hr"
          },
          events: {
            // @ts-ignore
            input: v => console.log(v)
          }
        },
        {
          id: "TextArea",
          type: "v-textarea",
          props: {
            counter: true,
            outline: true,
            label: "TextArea"
          }
        },
        {
          id: "Combobox",
          type: "v-combobox",
          props: {
            chips: true,
            label: "Combobox",
            items: ["Tunis", "Ariana"],
            outline: true
          }
        },
        {
          id: "nested.yes",
          type: "v-switch",
          props: {
            label: "switch"
          }
        },
        {
          id: "nested.checkbox",
          type: "v-checkbox",
          classes: "",
          props: {
            label: "switch1",
            value: "Oi"
          }
        },
        {
          id: "nested.checkbox",
          type: "v-checkbox",
          classes: "",
          props: {
            label: "switch",
            value: "Oi2"
          }
        },
        {
          id: "relation",
          type: "relation-input",
          props: {
            outline: true,
            label: "Relation",
            // @ts-ignore
            rules: [v => !!v || "category is required"],
            endpoint: "http://localhost:3000/api/Orgs",
            params: { filter: { something: "" } },
            itemText: "name",
            itemValue: "id"
          }
        },
        {
          id: "logo",
          type: "upload-input",
          required: true,
          classes: "xs12 md6",
          props: {
            outlined: true,
            label: "Logo",
            endpoint:
              "http://localhost:3000/api/Orgs/5b338580214cc324f4df01a1/files",
            path: "assets",
            // @ts-ignore
            rules: [v => !!v || "name is required"]
          }
        },
        {
          id: "colors.primary",
          type: "v-color-picker",
          required: true,
          classes: "xs12 md4",
          props: {
            outline: true,
            classes: "xs12 md4",
            label: "Couleur primaire"
          }
        } */
        {
          id: "video",
          type: "upload-input",
          props: {
            outlined: true,
            label: "video",
            endpoint: "http://localhost:3000/api/fileModels",
            // @ts-ignore
            rules: [v => !!v || "name is required"],
            type: "video"
          }
        }
      ],

      editedItem: {
        /*  text: "dsdsfg",
        time: "00:01",
        nested: {
          checkbox: ["Oi"]
        },
        logo: "5d697dd6984fca0112655044",
        relation: "5e3191c71b88770c362cc6d5" */
      }
    };
  },
  methods: {
    /*     changeData() {
      // @ts-ignore
      this.editedItem = {
        text: "sfdfds",
        // @ts-ignore
        password: "sdfs",
        number: "1111",
        date: "2000-02-02"
      };
    }, */
    validate() {
      console.log("validating");
      // @ts-ignore
      const isValid = this.$refs.form.validate();
      // @ts-ignore
      this.$refs.form.uploadFiles();
      console.log(isValid);
    }
  }
});
</script>
